#!/usr/local/bin/perl
# eLXgt@CScenarioTalk`xmlɕϊ
# ver 0.03
# 蔲:p
#
# XV
# 2003/08/25	0.03
# 	Zt⃁Ɂu<>&"'vƐɓǂ߂ȂsC
#
# 2003/07/03	0.02
# 	Ztɔpu#vAȍ~PsƂĎ荞ނ悤ɕύX

use strict;
use File::Spec;

main();
exit(0);

sub main()
{
	srand(time);
	my($infile) = $ARGV[0];
	exit(1) if($infile eq "");
	txt2xml($infile);
}

sub getTitle()
{
	my($title, $memo) = ("", "");
	while(<>){
		chomp;
		$_ = trim($_);
		if($title eq ""){
			$title = $_;
			next;
		}
		if($title ne "" && $_ eq ""){
			last;
		}
		$memo .= $_ . "\r\n";
	}
	return ($title, trim($memo));
}

sub txt2xml
{
	my($fCast) = 0;
	my(%hCast) = ("-----", 0);
	my($CastCnt) = 1;
	my($SerifCnt) = 0;
	my(%hSerif) = ();
	my($cast) = "";
	my($infile) = @_;
	my($outfile) = substr($infile, 0, rindex($infile, ".")) . ".xml";

	open(FILE, ">" . $outfile) or die "Can't open file [$outfile]\n";
	my($oldfh) = select(FILE);
	$| = 1;

	my($title, $memo) = getTitle();

	while(<>){
		chomp;
		$_ = trim($_);
		$_ = encodeXml($_);
		if($_ eq ""){
			$fCast = 0;
			next;
		}
		
		if($title eq ""){
			$title = $_;
		}
		
		if(/F$/){
			$fCast = 1;
			$cast = $`;
			if($cast ne "" && $hCast{$cast} eq ""){
				$hCast{$`} = $CastCnt;
				$CastCnt++;
			}
			next;
		}
		
		# Zt荞
		unless($fCast){
			$cast = "-----";
		}

		my($tmp_s, $tmp_m) = ($_);
		if(/#/){
			$tmp_s = trim($`);
			$tmp_m = trim($');
		}

		$hSerif{$SerifCnt} = $hCast{$cast} . "\t" . $tmp_s . "\t" . $tmp_m;
		$SerifCnt++;
	}

	print <<EOF;
<?xml version="1.0" encoding="Shift_JIS"?>
<script version="1.0">
	<title>
	$title
	</title>
	<memo>
	$memo
	</memo>
EOF

	for(sort{$hCast{$a} <=> $hCast{$b}} keys(%hCast)){
		print <<"EOF";
	<cast>
		<cast_id>
			$hCast{$_}
		</cast_id>
		<name>
			$_
		</name>
		<memo>
			
		</memo>
	</cast>
EOF
	}

	for(sort {$a <=> $b} keys(%hSerif)){
		my($cast_id, $serif, $lmemo) = split(/\t/,$hSerif{$_});
		print <<"EOF";
	<serif>
		<cast_id>
			$cast_id
		</cast_id>
		<serif>
			$serif
		</serif>
		<memo>
			$lmemo
		</memo>
	</serif>
EOF
	}


	print <<"EOF";
</script>
EOF

	select($oldfh);
}

sub GetColor
{
	my($color) = 0;
	for(;;){
		$color = int(rand(0x100));
		last if($color >= 0xB0);
	}
	return $color;
}

sub GetBkColor
{
	return sprintf("%06x", GetColor() << 16 | GetColor() << 8 | GetColor());
}

# Ő󔒁A^u폜
sub trim{
	my($str) = @_;
	$str =~ s/^[\t\s]*|[\t\s]*$//g;
	return $str;
}

# XMLGR[h
sub  encodeXml
{
	my($str) = @_;
	
	$str =~ s/&/&amp;/g;
	$str =~ s/"/&quot;/g;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/'/&apos;/g;
	
	return $str;
}
